
This consists of two machine problems(projects/assignments) that were done as part of
our Architecture of Parallel Computing course in Fall 2012. 

Machine Problem 1(mp1): 
In this assignment, we considered two approaches to inserting, looking up and deleting
nodes from a doubly linked list. In the global approach, we took a lock on the entire
linked list before performing the operations. In the fine grain approach, we took locks
only where necessary which improved overall performance by a significant margin.

Machine Problem 2(mp2):
INn this assignment, we implemented three of the cache coherency protocols for a 
multicore/multiprocessor system viz. MSI, MESI and MOESI.

Authors:
Nikhil Srivatsan Srinivasan(nsrivat@ncsu.edu)
Roshan George(rgeorge2@ncsu.edu)
